﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace RoboRace
{
    public class Connector
    {
        public string address;
        public const int LINES = 23;
        GameState currentState;

        public Connector(string Address)
        {
            address = Address;
            currentState = new GameState();
        }
        public GameState loadInitial()
        {
            WebClient client = new WebClient();
            Uri requestUri = new Uri(new Uri(address), "start");
            string response = client.DownloadString(requestUri);
            parseResponse(response);
            return currentState;
        }

        public GameState getCurrentState()
        {
            return currentState;
        }

        public void sendMoves(string moves)
        {
            WebClient client = new WebClient();
            Uri requestUri = new Uri(new Uri(address), "kolo?id=" + currentState.gameID + "&pohyby=" + moves);
            string response = client.DownloadString(requestUri);
            parseResponse(response);
        }

        private void parseResponse(string response)
        {
            string[] separator = {"\r\n"};
            string[] lines = response.Split(separator, StringSplitOptions.RemoveEmptyEntries);
            if (lines.Length == 1) { currentState.robotX = currentState.endX; currentState.robotY = currentState.endY; return; }
            currentState.gameID = int.Parse(lines[0]);
            for (int i = 1; i < LINES-2; i++)
            {
                for (int j = 0; j < lines[i].Length; j++)
                {
                    if (lines[i][j] == '$') { currentState.endX = j; currentState.endY = i-1; }
                    currentState.map[i-1][j] = lines[i][j];
                }
            }
            string[] positions = lines[LINES - 2].Split(' ');
            currentState.robotX = int.Parse(positions[0]) - 1;
            currentState.robotY = int.Parse(positions[1]) - 1;
            switch (positions[2][0])
            {
                case 'N': currentState.robotRotation = 0; break;
                case 'R': currentState.robotRotation = 1; break;
                case 'D': currentState.robotRotation = 2; break;
                case 'L': currentState.robotRotation = 3; break;
            }
            currentState.possibleMoves.Clear();
            foreach (char c in lines[LINES - 1])
            {
                currentState.possibleMoves.Add(c);
            }
        }
    }
}
